/*
 * Copyright 2009 bufferings[at]gmail.com
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND,
 * either express or implied. See the License for the specific language
 * governing permissions and limitations under the License.
 */
package bufferings.ktr.wjr.client;

import bufferings.ktr.wjr.client.widget.KtrWjrViewImpl;

import com.google.gwt.core.client.EntryPoint;
import com.google.gwt.core.client.GWT;
import com.google.gwt.user.client.ui.Panel;
import com.google.gwt.user.client.ui.RootPanel;

/**
 * Entry point classes define <code>onModuleLoad()</code>.
 * 
 * @author bufferings[at]gmail.com
 */
public class KtrWjr implements EntryPoint {

  /** ルートパネルのID */
  protected static final String ROOT_PANEL_ID = "KotoriWebJUnitRunner";

  /**
   * This is the entry point method.
   */
  public void onModuleLoad() {
    Panel panel = RootPanel.get(ROOT_PANEL_ID);
    if (panel == null) {
      GWT.log(ROOT_PANEL_ID + "が見つかりませんよー。", null);
    } else {
      GWT.log("KtrWjrを開始します。", null);
      KtrWjrViewImpl view = new KtrWjrViewImpl();
      KtrWjrPresenter presenter = new KtrWjrPresenter(view);
      view.initializeView(presenter, panel);
    }
  }
}
