/*
 * Copyright 2009 bufferings[at]gmail.com
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND,
 * either express or implied. See the License for the specific language
 * governing permissions and limitations under the License.
 */
package bufferings.ktr.wjr.client;

import com.google.gwt.user.client.ui.Panel;

/**
 * KtrWjrビューのインターフェイスです。
 * @author bufferings[at]gmail.com
 */
public interface KtrWjrView {

  /**
   * ビューを初期化します。
   * @param presenter プレゼンター
   * @param parent ビューの親となるパネル
   */
  public void initializeView(KtrWjrPresenter presenter, Panel parent);

  public void onLoadTestStoreConfigsFailure();

  public void onLoadTestStoreConfigsSuccess();

  public void onLoadTestStoreFailure(String storeName);

  public void onLoadTestStoreSuccess(String storeName);

  public void onRunTestsCancel(String storeName);

  public void onRunTestsFailure(String storeName);

  public void onRunTestsSuccess(String storeName);

  public void onRunTestsUpdate(String storeName);
}
