/*
 * Copyright 2009 bufferings[at]gmail.com
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND,
 * either express or implied. See the License for the specific language
 * governing permissions and limitations under the License.
 */
package bufferings.ktr.wjr.client.service;

import java.util.List;

import bufferings.ktr.wjr.shared.model.TestCaseModel;
import bufferings.ktr.wjr.shared.model.TestStore;
import bufferings.ktr.wjr.shared.model.TestStoreConfig;

import com.google.gwt.user.client.rpc.AsyncCallback;

/**
 * A proxy class for calling KtrWjr service.
 * 
 * @author bufferings[at]gmail.com
 * @see KtrWjrService
 */
public interface KtrWjrServiceAsync {

  void loadTestStoreConfigs(AsyncCallback<List<TestStoreConfig>> callback);

  void loadTestStore(String storeKey, AsyncCallback<TestStore> callback);

  void runTests(List<TestCaseModel> testCases,
      AsyncCallback<List<TestCaseModel>> callback);

}
