/*
 * Copyright 2009 bufferings[at]gmail.com
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND,
 * either express or implied. See the License for the specific language
 * governing permissions and limitations under the License.
 */
 package bufferings.ktr.wjr.client.widget;

import com.google.gwt.user.client.Element;
import com.google.gwt.user.client.ui.AbstractImagePrototype;
import com.google.gwt.user.client.ui.Image;
import com.google.gwt.user.client.ui.TreeImages;

public class KtrTreeImages implements TreeImages {

  /**
   * A convenience image prototype that implements
   * {@link AbstractImagePrototype#applyTo(Image)} for a specified image name.
   */
  private class Prototype extends AbstractImagePrototype {
    KtrIcon icon;

    public Prototype(KtrIcon icon) {
      this.icon = icon;
    }

    @Override
    public void applyTo(Image image) {
      // NOP
    }

    @Override
    public void applyTo(ImagePrototypeElement img) {
      img.setClassName(icon.getStyleName());
    }

    @Override
    public ImagePrototypeElement createElement() {
      Element img = icon.getElement();
      applyTo(img.<ImagePrototypeElement> cast());
      return img.cast();
    }

    @Override
    public Image createImage() {
      // NOTE: This class is only used internally and, therefore only needs
      // to support applyTo(Image).
      throw new UnsupportedOperationException("createImage is unsupported.");
    }

    @Override
    public String getHTML() {
      // NOTE: This class is only used internally and, therefore only needs
      // to support applyTo(Image).
      throw new UnsupportedOperationException("getHTML is unsupported.");
    }
  }

  public AbstractImagePrototype treeClosed() {
    return new Prototype(new KtrIcon.Triangle1E());
  }

  public AbstractImagePrototype treeLeaf() {
    return new Prototype(new KtrIcon.Empty());
  }

  public AbstractImagePrototype treeOpen() {
    return new Prototype(new KtrIcon.Triangle1S());
  }

}
