/*
 * Copyright 2009 bufferings[at]gmail.com
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND,
 * either express or implied. See the License for the specific language
 * governing permissions and limitations under the License.
 */
 package bufferings.ktr.wjr.client.widget;

import com.google.gwt.user.client.ui.Composite;
import com.google.gwt.user.client.ui.HorizontalPanel;
import com.google.gwt.user.client.ui.Label;
import com.google.gwt.user.client.ui.VerticalPanel;
import com.google.gwt.user.client.ui.Widget;

public class ResultComposite extends Composite {
  protected KtrIconLabel total;
  protected KtrIconLabel error;
  protected KtrIconLabel failure;
  protected Label result;

  public ResultComposite() {
    VerticalPanel widget = new VerticalPanel();
    widget.add(createHeader());
    widget.add(createContent());
    widget.setStyleName("");
    initWidget(widget);
  }

  protected Widget createHeader() {
    HorizontalPanel header = new HorizontalPanel();
    header.add(new KtrIconLabel(new KtrIcon.Note(), "Result"));
    header.setStyleName("ui-widget-header");
    header.setWidth("100%");
    header.setSpacing(1);
    return header;
  }

  protected Widget createContent() {
    total = new KtrIconLabel(new KtrIcon.Document());
    error = new KtrIconLabel(new KtrIcon.CircleClose());
    failure = new KtrIconLabel(new KtrIcon.Alert());

    HorizontalPanel panel = new HorizontalPanel();
    panel.add(total);
    panel.add(error);
    panel.add(failure);
    panel.setWidth("95%");
    panel.setStyleName("");

    result = new Label();
    result.setSize("95%", "16px");
    result.setStyleName("");

    VerticalPanel content = new VerticalPanel();
    content.setHorizontalAlignment(VerticalPanel.ALIGN_CENTER);
    content.add(panel);
    content.add(result);
    content.setStyleName("ui-widget-content");
    content.setWidth("100%");
    content.setSpacing(3);
    return content;
  }

  public void setValue(int totalCnt, int successCnt, int failureCnt,
      int errorCnt, int notyetCnt) {

    int runCnt = successCnt + failureCnt + errorCnt;

    total.setText("Run: " + runCnt + "/" + totalCnt);
    error.setText("Error: " + Integer.toString(errorCnt));
    failure.setText("Failure: " + Integer.toString(failureCnt));

    if (totalCnt == notyetCnt) {
      result.setStyleName("ktr-result-bar-default");
    } else if (failureCnt + errorCnt > 0) {
      result.setStyleName("ktr-result-bar-fail");
//    } else if (notyetCnt > 0) {
//      result.setStyleName("ktr-result-bar-notyet");
    } else {
      result.setStyleName("ktr-result-bar-succeed");
    }
  }
}
