package bufferings.ktr.wjr.client.widget;

import com.google.gwt.dom.client.Style;
import com.google.gwt.user.client.DOM;
import com.google.gwt.user.client.Window;
import com.google.gwt.user.client.ui.HorizontalPanel;
import com.google.gwt.user.client.ui.Label;
import com.google.gwt.user.client.ui.RootPanel;
import com.google.gwt.user.client.ui.SimplePanel;

public class RunningPopup extends SimplePanel {

  protected boolean isShowing = false;

  protected boolean isHiding = false;

  public RunningPopup() {
    super();

    HorizontalPanel mainPanel = new HorizontalPanel();
    mainPanel.setHorizontalAlignment(HorizontalPanel.ALIGN_CENTER);
    mainPanel.setVerticalAlignment(HorizontalPanel.ALIGN_MIDDLE);
    mainPanel.setSpacing(5);
    mainPanel.add(new Label("Running..."));
    mainPanel.setSize("100%", "100%");
    setWidget(mainPanel);

    DOM.setStyleAttribute(getElement(), "position", "absolute");
    setVisible(false);
    setStyleName("ui-state-highlight");
    setSize("200px", "30px");
    getElement().getStyle().setPropertyPx("left", -9999);
    getElement().setId(DOM.createUniqueId());

    RootPanel.get().add(this);
  }

  public void adjustPosition() {
    int left = 13;
    int top = (Window.getClientHeight() - 48);

    left += Window.getScrollLeft();
    top += Window.getScrollTop();

    Style style = getElement().getStyle();
    style.setPropertyPx("left", left);
    style.setPropertyPx("top", top);
  }

  public void show() {
    if (isVisible() || isShowing) {
      return;
    }
    isShowing = true;
    adjustPosition();
    showAnimation(getElement().getId());
  }

  protected void showCallback() {
    isShowing = false;
  }

  public void hide() {
    if (!isVisible() || isHiding) {
      return;
    }
    isHiding = true;
    hideAnimation(getElement().getId());
  }

  protected void hideCallback() {
    isHiding = false;
  }

  private native void showAnimation(String id)/*-{
    var options = {}
    var callback = this.@bufferings.ktr.wjr.client.widget.RunningPopup::showCallback()();
    $wnd.$("#" + id).show('slide', options, 500, callback);
  }-*/;

  public native void hideAnimation(String id)/*-{
    var options = {}
    var callback = this.@bufferings.ktr.wjr.client.widget.RunningPopup::hideCallback()();
    $wnd.$("#" + id).hide('slide', options, 500, callback);
  }-*/;
}
