/*
 * Copyright 2009 bufferings[at]gmail.com
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND,
 * either express or implied. See the License for the specific language
 * governing permissions and limitations under the License.
 */
 package bufferings.ktr.wjr.server.service;

import java.util.List;

import bufferings.ktr.wjr.client.service.KtrWjrService;
import bufferings.ktr.wjr.shared.model.TestCaseModel;
import bufferings.ktr.wjr.shared.model.TestStore;
import bufferings.ktr.wjr.shared.model.TestStoreConfig;

import com.google.gwt.user.server.rpc.RemoteServiceServlet;

/**
 * A KtrWjrService servlet for running out of Slim3 environment.
 * <p>
 * This servlet delegates all operations to {@link KtrWjrServiceImpl}.
 * </p>
 * 
 * @author bufferings[at]gmail.com
 */
public class KtrWjrServiceServlet extends RemoteServiceServlet implements
    KtrWjrService {

  private static final long serialVersionUID = 1L;

  /** delegation */
  protected KtrWjrServiceImpl delegate = new KtrWjrServiceImpl();

  /** {@inheritDoc} */
  public TestStore loadTestStore(String testStoreName) {
    return delegate.loadTestStore(testStoreName);
  }

  /** {@inheritDoc} */
  public List<TestStoreConfig> loadTestStoreConfigs() {
    return delegate.loadTestStoreConfigs();
  }

  /** {@inheritDoc} */
  public List<TestCaseModel> runTests(List<TestCaseModel> testCaseModels) {
    return delegate.runTests(testCaseModels);
  }

}
