package bufferings.ktr.wjr.server.service.junit3;

import java.lang.reflect.Method;
import java.lang.reflect.Modifier;

import junit.framework.TestCase;
import bufferings.ktr.wjr.shared.model.TestCaseModel;
import bufferings.ktr.wjr.shared.model.TestStore;
import bufferings.ktr.wjr.shared.model.TestSuiteModel;

public class TestCaseChecker3 {
  /** {@inheritDoc} */
  public boolean checkAndAddTestCase(TestStore store, Class<?> c) {
    if (!(TestCase.class.isAssignableFrom(c))) {
      return false;
    }

    TestSuiteModel suite = null;
    Method[] methods = c.getDeclaredMethods();
    for (Method m : methods) {
      // public only
      if (m.getModifiers() == Modifier.PUBLIC && m.getName().startsWith("test")) {
        if (suite == null) {
          suite = new TestSuiteModel(c.getCanonicalName(), c.getSimpleName());
          store.add(suite);
        }
        store.add(suite.getKey(), new TestCaseModel(c.getCanonicalName(), m
          .getName()));
      }
    }
    return suite != null;
  }
}
