package bufferings.ktr.wjr.server.service.junit4;

import java.lang.reflect.Method;
import java.lang.reflect.Modifier;

import org.junit.Ignore;
import org.junit.Test;

import bufferings.ktr.wjr.shared.model.TestCaseModel;
import bufferings.ktr.wjr.shared.model.TestStore;
import bufferings.ktr.wjr.shared.model.TestSuiteModel;

public class TestCaseChecker4 {
  /** {@inheritDoc} */
  public boolean checkAndAddTestCase(TestStore store, Class<?> c) {
    TestSuiteModel suite = null;
    Method[] methods = c.getDeclaredMethods();
    for (Method m : methods) {
      // public only
      if (m.getModifiers() == Modifier.PUBLIC
        && m.getAnnotation(Test.class) != null
        && m.getAnnotation(Ignore.class) == null) {
        if (suite == null) {
          suite = new TestSuiteModel(c.getCanonicalName(), c.getSimpleName());
          store.add(suite);
        }
        store.add(suite.getKey(), new TestCaseModel(c.getCanonicalName(), m
          .getName()));
      }
    }
    return suite != null;
  }
}
