/*
 * Copyright 2009 bufferings[at]gmail.com
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND,
 * either express or implied. See the License for the specific language
 * governing permissions and limitations under the License.
 */
package bufferings.ktr.wjr.shared.model;

import java.io.Serializable;

/**
 * A filter of a test case model.
 * 
 * @author bufferings[at]gmail.com
 */
public interface TestCaseModelFilter extends Serializable {

  /**
   * Check if the test case model matches the condition.
   * 
   * @param testCaseModel
   *          a test case model
   * @return true if matches, false if not.
   */
  public boolean match(TestCaseModel testCaseModel);
}
