/*
 * Copyright 2009 bufferings[at]gmail.com
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND,
 * either express or implied. See the License for the specific language
 * governing permissions and limitations under the License.
 */
 package bufferings.ktr.wjr.shared.model;

import java.io.Serializable;

/**
 * An interface of test item.
 * 
 * @author bufferings[at]gmail.com
 */
public interface TestStoreItem extends Serializable {

  /**
   * An enumeration representing test item run state.
   * 
   * @author bufferings[at]gmail.com
   */
  public enum State {
    NOT_YET, SUCCESS, FAILURE, ERROR,
    /** (for only a test suite model) suite contains not run test case */
    SUITE_HAS_NOT_YET
  }

  /**
   * Gets the key string.
   * 
   * @return key string
   */
  public String getKey();

  /**
   * Gets the test item name.
   * 
   * @return test item name
   */
  public String getName();

  /**
   * Gets the test item run status.
   * 
   * @return test
   */
  public State getState();

  public void clearResult();
}
